<!--
 * @Date: 2024-10-08 14:29:36
 * @LastEditors: shirlwang
 * @LastEditTime: 2025-11-06 12:09:11
-->
<template>
	
	<view class="input-outer-part">
		<scroll-view scroll-y="true" :style="{height: edit?'calc(100vh - 380rpx)':'calc(100vh - 194rpx)'}">
			<view class="inner">
				<view class="part-title" style="display: flex;justify-content: space-between;">需求信息
					<view v-if="!edit&&formData.id&&formData.currentStatus!=3" class="btn"
						style="font-weight: normal;display: flex;" @click="edit=true">编辑<u-icon name="edit-pen"
							color="#A6A6A6"></u-icon></view>
				</view>
				<view class="inner-part">
					<uni-forms labelPosition="right" :model="formData" :rules="rules" ref="uForm" class="self-form"
						labelWidth="150rpx">
						<uni-forms-item label="姓名" prop="personName" required
							v-if="$store.getters.roles.includes('shequn')|| $store.getters.roles.includes('gly')">
							<view class="input-area" style="width: 100%;" @click="openPersonChooser"
								:class="{disabledLine: !edit||!canChoosePerson, noValue: !formData.personName}">
								{{ formData.personName || '请选择' }}
							</view>
							<u-icon slot="right" name="edit-pen" color="#A6A6A6"></u-icon>
						</uni-forms-item>

						<uni-forms-item label="需求说明" prop="jobDescription" required>
							<textarea style="width: 100%;box-sizing: border-box;" class="textarea" :disabled="!edit" v-model="formData.jobDescription" placeholder="请输入"></textarea>
						</uni-forms-item>
					</uni-forms>
				</view>
			</view>
			<!-- 办理完成后 需求说明 -->
			<req-comp :form="{
				actualSolveDate: formData.actualSolveDate,
				actualSolvePeople: formData.actualSolvePeople,
				solveDesc: formData.solveDesc,
				fileUrl: formData.fileUrl
			}" />
		</scroll-view>
		<u-datetime-picker :show="show.hopeSolveDate" v-model="dates.hopeSolveDate" mode="date"
			@confirm="confirmDate('hopeSolveDate', $event)" @cancel="cancelPicker('hopeSolveDate')"></u-datetime-picker>
		<choose-person ref="personChooser" @confirm="personNameConfirm" />
		<view class="button-area" v-if="edit">
			<view class="btn" @click="cancelPage">取消</view>
			<view class="btn reset" @click="getDetail(formData.id)">重置</view>
			<view class="btn save" @click="saveInfo">保存</view>
		</view>
	</view>
</template>

<script>
	import {
		getPersonBase
	} from "@/packageRc/apiRc/person";
				import {
		addPersonDemand,
		updatePersonDemand,
		getPersonDemand
	} from "@/packageRc/apiRc/needs/personDemand";
	import ImageUpload from '/packageRc/components/ImageUpload'
	import ChoosePerson from '/packageRc/pages/needs/components/choosePerson';
		import {
		listJobType
	} from "@/packageRc/apiRc/jobType/index";
	import dayjs from "dayjs";

	export default {
		components: {
			ChoosePerson,
			ImageUpload
		},
								props: {
									needId: {
				type: String,
				default: ''
			},
			name: {
				type: String,
				default: ''
			}
		},
		data() {
			return {
				fileList: [],
				edit: true,
				personBase: {},
				dates: {},
				formData: {
					isAcceptAssistance: '',
					isAcceptApprovalResult: '',
					qtxqsm: ''
				},
				rules: {
					personName: [{
						required: true,
						message: '请填写姓名',
						trigger: ['blur', 'change'],
					}, ],
					qtxqsm: [{
						required: true,
						message: '请填写需求说明',
						trigger: ['blur', 'change'],
					}, ],
				},
				dict: {},
				show: {},
				currentCityArr: [],
				originalDept: [],
				currentCity: '请选择',
				bysj: '',
				loading: false,
				jobTypeList: [],
				route: {},
				canChoosePerson: false,
			}
		},
		onReady() {
			this.$refs.uForm.setRules(this.rules)
		},
		created() {
			this.loading = true;
		},
		methods: {
			cancelPage() {
				if (this.formData.id) {
					this.edit = false;
					this.getDetail(this.formData.id)
				} else {
					uni.navigateBack()
				}
			},
			workTypeRemoteMethod(key) {
				listJobType({
					workTypeName: key,
					pageNum: 1,
					pageSize: 50
				}).then(
					(res) => {
						this.jobTypeList = res.rows;
					}
				);
			},
			openPersonChooser() {
				if (this.edit && this.canChoosePerson) {
					this.$refs.personChooser.open();
				}
			},
			personNameConfirm(event) {
				this.formData.personName = event.name
				this.formData.personId = event.id
				this.formData.userId = event.userId
				this.formNameChange();
				this.$forceUpdate();
			},
			changeFile(e) {
				// 清空当前的 fileUrl 数组
				this.formData.fileUrl = [];
				// 如果 e 有长度（即用户选择了文件）
				if (e.length) {
					// 遍历每个文件对象并获取其 url
					for (let data of e) {
						const url = data.data ? data.data.url : data.url;
						this.formData.fileUrl.push(url);
					}
				}
				this.formData.fileUrl = this.$arrayToString(this.formData.fileUrl)
			},
			addOne(userId) {
				this.formData = {}
				this.getPersonInfo()
				if(this.name){
					this.formData.personName = this.name
					this.formData.userId = userId
				}
				this.edit = true

			},
			getDetail(id) {
				getPersonDemand(id).then(res => {
					this.formData = res.data;
					this.edit = false
				})
			},
			confirmDate(type, e) {
				this.show[type] = false;
				let date = new Date(e.value)
				this.formData[type] =
					`${date.getFullYear()}-${(date.getMonth()+1)>9?(date.getMonth()+1):('0'+(date.getMonth()+1))}-${date.getDate()>9?date.getDate():('0'+date.getDate())}`
				this.$forceUpdate();
			},
			goBack() {
				uni.navigateBack();
			},
			cancelPicker(type) {
				this.show[type] = false
				this.$forceUpdate();
			},
			getDictLabel(value, list) {
				if (list) {
					let arr = list.filter(ele => ele.dictValue == value)
					if (arr.length) {
						return arr[0].dictLabel
					} else {
						return '请选择'
					}
				}
			},
			pickerConfirm(type, event) {
				this.show[type] = false
				this.formData[type] = event.value[0].dictValue
				this.$forceUpdate();
			},
			showPicker(type) {
				if (this.edit) {
					this.show[type] = true
					this.$forceUpdate()
				}
			},
			getPersonInfo() {
				this.loading = true;
				this.$store.dispatch("GetInfo").then((res) => {
					if (res.data.roles.indexOf('qunzhong') == -1) {
						this.canChoosePerson = true;
					} else {
						this.canChoosePerson = false;
						getPersonBase(res.data.user.userId).then(resp => {
							this.formData.personId = resp.data.id
							this.formData.userId = resp.data.userId
							this.formData.personName = resp.data.name
							this.formNameChange();
							this.$forceUpdate();
						})
					}
				})
			},
			formNameChange() {
				let date = new Date()
				let day =
					`${date.getFullYear()}-${(date.getMonth()+1) + 1 > 9 ? (date.getMonth()+1) + 1: '0'+((date.getMonth()+1) + 1)}-${date.getDate() > 9 ? date.getDate(): '0'+date.getDate()}`
				const dayNew = dayjs(date).format("YYYY-MM-DD");
				this.formData.demandTitle = `${this.formData.personName}_于${dayNew}_提出其他需求`
			},
			async saveInfo() {
				uni.showLoading();
				try {
					// 验证表单
					const isValid = await this.$refs.uForm.validate();
					if (!isValid) {
						throw new Error('请检查必填项填写');
					}
					// 显示全局加载

					// 根据 formData 是否有 id 来决定是更新还是新增
					let response;
					let successMessage;
					this.formData.demandType = 9;
					// this.formData.userId = this.formData.personId
					if (this.formData.id) {
						updatePersonDemand(this.formData).then(response => {
							uni.showToast({title: '修改成功', icon: 'none'});
							if (response.code == 200) {
								// 如果是编辑模式，关闭编辑状态；否则返回上一页
								if (this.formData.id) {
									this.edit = false;
								} else {
									setTimeout(() => {
										uni.navigateBack();
									}, 2000);
								}
							}
							uni.hideLoading();
						})
					} else {
						addPersonDemand(this.formData).then(response => {
							uni.showToast({title: '保存成功', icon: 'none'});
							if (response.code == 200) {
								// 如果是编辑模式，关闭编辑状态；否则返回上一页
								if (this.formData.id) {
									this.edit = false;
								} else {
									setTimeout(() => {
										uni.navigateBack();
									}, 2000);
								}
							}
							uni.hideLoading();
						})
					}
				} catch (error) {
					if(error.length){
						this.$u.toast('请填写完整信息！');
					}else{
						this.$u.toast('系统错误,请联系管理员！');
					}
				} finally {
					// 确保加载页总是会被隐藏
					uni.hideLoading();
				}
			}

			// saveInfo() {
			// 	this.$refs.uForm.validate().then(res => {
			// 		if (this.formData.id) {
			// 			updatePersonDemand(this.formData).then(res => {
			// 				if (res.code == 200) {
			// 					uni.showToast({
			// 						title: '修改成功'
			// 					})
			// 					this.edit = false;
			// 				}
			// 			})
			// 		} else {
			// 			addPersonDemand(this.formData).then(res => {
			// 				if (res.code == 200) {
			// 					uni.showToast({
			// 						title: '保存成功'
			// 					})
			// 					uni.navigateBack();
			// 				}
			// 			})
			// 		}
			// 	}).catch(() => {
			// 		uni.showToast({
			// 			title: '请检查必填项填写',
			// 			icon: 'none'
			// 		})
			// 	})
			// }
		}
	}
</script>

<style lang="scss">

	.noValue {
		color: rgb(192, 196, 204);
	}

.input-area{
	padding: 0 24rpx;
	height: 64rpx;
	display: flex;
	align-items: center;
	border: 1px solid #e4e4e4;
	border-radius: 8rpx;
	box-sizing: border-box;
	// &input{
		
	// }
}
textarea{
	box-sizing: border-box;
	border: 1px solid #e4e4e4;
	border-radius: 8rpx;
	font-size: 26rpx;
	padding: 12rpx;
}




.picker-view {
  display: flex;
  align-items: center;
  justify-content: space-between;
  // width: 100%;
  padding: 0 24rpx;
	height: 64rpx;
	display: flex;
	align-items: center;
  background: #ffffff;
  border: 2rpx solid #e5e5e5;
  border-radius: 12rpx;
  box-sizing: border-box;
  transition: all 0.3s ease;
}
	.disabledLine {
		background: rgb(245, 247, 250);
		cursor: not-allowed;
	}
</style>
